local map = vim.keymap.set
local dap = require("dap")
local term = require("nvterm.terminal")

map("n", "<C-left>", "<C-o>", { desc = "LSP Back" })
map("n", "<C-right>", "<C-i>", { desc = "LSP Forward" })

map("v", "<C-c>", '"+y', { desc = "Copy selected" })
map({ "i", "n" }, "<C-v>", '<ESC>"+p', { desc = "Past" })

map({ "n", "v", "i" }, "<C-s>", "<ESC>:w<CR>", { desc = "Save file" })

map("n", "<C-S-left>", "<C-w>h", { desc = "switch window left" })
map("n", "<C-S-right>", "<C-w>l", { desc = "switch window right" })
map("n", "<C-S-down>", "<C-w>j", { desc = "switch window down" })
map("n", "<C-S-up>", "<C-w>k", { desc = "switch window up" })

map("n", "<C-q>", ":q<CR>", { desc = "close window" })

map("n", "<C-/>", "gcc", { desc = "toggle comment", remap = true })
map("v", "<C-/>", "gc", { desc = "toggle comment", remap = true })

-- neo-tree
map({ "n", "v" }, "<leader>e", ":Neotree<CR>", { desc = "nvimtree focus window" })
map({ "n", "v" }, "<leader>g", ":Neotree git_status float<CR>", { desc = "open gis status" })

-- telescope
map("n", "<leader>ff", ":Telescope live_grep<CR>", { desc = "telescope live grep" })
map("n", "<leader>r", ":Telescope lsp_references<CR>", { desc = "telescope lsp references" })

-- barbar
map("n", "<tab>", ":BufferNext<CR>", { desc = "Next tab" })
map("n", "<S-tab>", ":BufferPrevious<CR>", { desc = "Previous tab" })

-- dap
map("n", "<leader>bb", dap.toggle_breakpoint, { desc = "Toggle breakpoint" })

-- nvterm
map("n", "<C-t>", function()
	term.toggle("horizontal")
end, { desc = "Open terminal" })

-- menu
local menu = require("menu")

map("n", "<A-CR>", function()
	local ft = vim.bo.ft
	if ft ~= "neo-tree" then
		menu.open(require("config.menu"), { border = true })
	end
end)

require("langmapper").automapping({ global = true, buffer = true })
